package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.List;
import org.antlr.grammar.v3.ANTLRv3Lexer;
import org.antlr.grammar.v3.ANTLRv3Parser;
import org.antlr.runtime.ANTLRFileStream;
import org.antlr.runtime.ANTLRInputStream;
import org.antlr.runtime.CharStream;
import org.antlr.runtime.Token;
import org.antlr.runtime.TokenRewriteStream;
import org.antlr.runtime.tree.CommonTree;
import org.antlr.runtime.tree.TreeAdaptor;
import org.antlr.runtime.tree.TreeWizard;

public class Strip {
  protected String filename;
  
  protected TokenRewriteStream tokens;
  
  protected boolean tree_option = false;
  
  protected String[] args;
  
  public static void main(String[] args) throws Exception {
    org.antlr.tool.Strip s = new org.antlr.tool.Strip(args);
    s.parseAndRewrite();
    System.out.println(s.tokens);
  }
  
  public Strip(String[] args) {
    this.args = args;
  }
  
  public TokenRewriteStream getTokenStream() {
    return this.tokens;
  }
  
  public void parseAndRewrite() throws Exception {
    CharStream input;
    processArgs(this.args);
    if (this.filename != null) {
      input = new ANTLRFileStream(this.filename);
    } else {
      input = new ANTLRInputStream(System.in);
    } 
    ANTLRv3Lexer lex = new ANTLRv3Lexer(input);
    this.tokens = new TokenRewriteStream(lex);
    ANTLRv3Parser g = new ANTLRv3Parser(this.tokens);
    ANTLRv3Parser.grammarDef_return r = g.grammarDef();
    CommonTree t = r.getTree();
    if (this.tree_option)
      System.out.println(t.toStringTree()); 
    rewrite(g.getTreeAdaptor(), t, g.getTokenNames());
  }
  
  public void rewrite(TreeAdaptor adaptor, CommonTree t, String[] tokenNames) throws Exception {
    TreeWizard wiz = new TreeWizard(adaptor, tokenNames);
    wiz.visit(t, 4, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 12, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 9, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 47, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 53, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 29, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 52, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 11, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 33, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 36, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 48, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 49, (TreeWizard.ContextVisitor)new Object(this));
    wiz.visit(t, 14, (TreeWizard.ContextVisitor)new Object(this));
  }
  
  public static void ACTION(TokenRewriteStream tokens, CommonTree t) {
    CommonTree parent = (CommonTree)t.getParent();
    int ptype = parent.getType();
    if (ptype == 52 || ptype == 12)
      return; 
    CommonTree root = (CommonTree)t.getAncestor(50);
    if (root != null) {
      CommonTree rule = (CommonTree)root.getChild(0);
      if (!Character.isUpperCase(rule.getText().charAt(0))) {
        tokens.delete(t.getTokenStartIndex(), t.getTokenStopIndex());
        killTrailingNewline(tokens, t.token.getTokenIndex());
      } 
    } 
  }
  
  private static void killTrailingNewline(TokenRewriteStream tokens, int index) {
    List<? extends Token> all = tokens.getTokens();
    Token tok = all.get(index);
    Token after = all.get(index + 1);
    String ws = after.getText();
    if (ws.startsWith("\n"))
      if (ws.length() > 1) {
        int space = ws.indexOf(' ');
        int tab = ws.indexOf('\t');
        if ((ws.startsWith("\n") && space >= 0) || tab >= 0)
          return; 
        ws = ws.replaceAll("\n", "");
        tokens.replace(after.getTokenIndex(), ws);
      } else {
        tokens.delete(after.getTokenIndex());
      }  
  }
  
  public void processArgs(String[] args) {
    if (args == null || args.length == 0) {
      help();
      return;
    } 
    for (int i = 0; i < args.length; i++) {
      if (args[i].equals("-tree")) {
        this.tree_option = true;
      } else if (args[i].charAt(0) != '-') {
        this.filename = args[i];
      } 
    } 
  }
  
  private static void help() {
    System.err.println("usage: java org.antlr.tool.Strip [args] file.g");
    System.err.println("  -tree      print out ANTLR grammar AST");
  }
}
